.\" @(#)xlock.man	4.00 97/01/01
.\" Copyright (c) 1991 - Patrick J. Naughton
.\" xlockmore updates from David A. Bagley
.TH XLOCK 1 "01 Jan 1997" "X11R6 Contrib"
.SH NAME
xlock \- Locks the local X display until a password is entered.
.sp
.IX xlock#(1) "" "\fLxlock\fP(1)"
.SH SYNOPSIS
.B xlock
[
.BI \-help
]
[
.BI \-version
]
[
.BI \-resources
]
[
.BI \-display " displayname"
]
[
.BI \-visual " visualname"
]
[
.BI \-name " resourcename"
]
[
.BI \-mode " modename"
]
[
.BI \-delay " usecs"
]
[
.BI \-batchcount " num"
]
[
.BI \-cycles " num"
]
[
.BI \-saturation " value"
]
[
.BI -/+allowaccess
]
[
.BI -/+nolock
]
[
.BI -/+inwindow
]
[
.BI -/+inroot
]
[
.BI -/+remote
]
[
.BI -/+mono
]
[
.BI -/+allowroot
]
[
.BI -/+debug
]
[
.BI -/+echokeys
]
[
.BI -/+enablesaver
]
[
.BI -/+grabmouse
]
[
.BI -/+install
]
[
.BI -/+sound
]
[
.BI -/+timeelapsed
]
[
.BI -/+usefirst
]
[
.BI -/+verbose
]
[
.BI \-nice " level"
]
[
.BI \-lockdelay " seconds"
]
[
.BI \-timeout " seconds"
]
[
.BI \-font " fontname"
]
[
.BI \-msgfont " message-fontname"
]
[
.BI \-bg " color"
]
[
.BI \-fg " color"
]
[
.BI \-background " color"
]
[
.BI \-foreground " color"
]
[
.BI \-username " string"
]
[
.BI \-password " string"
]
[
.BI \-info " string"
]
[
.BI \-validate " string"
]
[
.BI \-invalid " string"
]
[
.BI \-geometry " geom"
]
[
.BI \-icongeometry " geom"
]
[
.BI -/+fullrandom
]
[
.BI -/+wireframe
]
[
.BI -/+use3d
]
[
.BI \-delta3d " value"
]
[
.BI \-none3d " color"
]
[
.BI \-right3d " color"
]
[
.BI \-left3d " color"
]
[
.BI \-both3d " color"
]
[
.BI \-program " programname"
]
[
.BI \-messagesfile " formatted-filename"
]
[
.BI \-messagefile " filename"
]
[
.BI \-message " string"
]
[
.BI \-mfont " mode-fontname"
]
[
.BI \-imagefile " filename"
]
[
.BI \-neighbors " num"
]
[
.BI \-cpasswd " crypted-password"
]
[
.BI \-forceLogout " minutes"
]
[
.BI \-logoutButtonLabel " textstring"
]
[
.BI \-logoutButtonHelp " textstring"
]
[
.BI \-logoutFailedString " textstring"
]
[
.BI -/+dtsaver
]
[
.BI \-locksound " string"
]
[
.BI \-infosound " string"
]
[
.BI \-validsound " string"
]
[
.BI \-invalidsound " string"
]

.SH DESCRIPTION
.B xlock
locks the X server till the user enters their password at the keyboard.
While
.B xlock
is running,
all new server connections are refused.
The screen saver is disabled.
The mouse cursor is turned off.
The screen is blanked and a changing pattern is put on the screen.
If a key or a mouse button is pressed then the user is prompted for the
password of the user who started
.BR xlock .

If the correct password is typed, then the screen is unlocked and the X
server is restored.  When typing the password Control-U and Control-H are
active as kill and erase respectively.  To return to the locked screen,
click in the small icon version of the changing pattern.

In the lower part of the password screen a message is displayed.  This
message is taken from the first file of the following that exists:
$HOME/.xlockmessage, $HOME/.plan, or $HOME/.signature.

On systems which support new BSD style authentication, the password
may be prefixed by an authentication style followed by a colon
(i.e. "style:password").  See the login.conf(5) for more information
on authentication styles.

.SH "NOTE ON ETIQUETTE"
.I Xlock
should not be used on public terminals when there is a high demand for them.

If you find a public terminal that has been locked by another user and
there are no other terminals available, and the terminal appears to have
been left idle for a while (normally more than 15 minutes), it is fair to
try to reset the session in some manner.

.SH OPTIONS
.TP 5
.BI \-help
Print options and a brief description to standard output.
.TP 5
.BI \-version
Print version number (if >= 4.00) to standard output.
.TP 5
.BI \-resources
Print default resource file to standard output.
.TP 5
.BI \-display \ displayname
The
.I display
option sets the X11 display to lock.
.B xlock
locks all available screens on a given server,
and restricts you to locking only a local server such as
.BI unix:0,
.BI localhost:0,
or
.BI :0
unless you set the
.B \-remote
option.
.TP 5
.BI \-visual \ visualname
.I visualname
which is one of "StaticGray", "GrayScale", "StaticColor", "PseudoColor",
"TrueColor", or "DirectColor".  May not be available depending on how it
is initially configured.  This is under construction.
.TP 5
.BI \-name \ resourcename
.I resourcename
is used instead of
.B XLock
when looking for resources to configure
.BR xlock .
.TP 5
.BI \-mode \ modename
As of this writing there are over 60 display modes supported
(plus one more for random selection of one of these).
.TP 8
.B ant
Shows Langton's and Turk's generalized ants.
.TP 8
.B ball
Shows bouncing balls.
.TP 8
.B bat
Shows bouncing flying bats.
.TP 8
.B blot
Shows Rorschach's ink blot test.
.TP 8
.B bouboule
Shows Mimi's bouboule of moving stars.
.TP 8
.B bounce
Shows bouncing footballs.
.TP 8
.B braid
Shows random braids and knots.
.TP 8
.B bug
Shows Palmiter's bug evolution and a garden of Eden.
.TP 8
.B cartoon
Shows bouncing cartoons.  Not compiled in by default.
.TP 8
.B clock
Shows Packard's oclock.
.TP 8
.B daisy
Shows a meadow of daisies.
.TP 8
.B dclock
Shows a floating digital clock.
.TP 8
.B demon
Shows Griffeath's cellular automata.
.TP 8
.B drift
Shows cosmic drifting flame fractals.
.TP 8
.B eyes
Shows eyes following a bouncing grelb.
.TP 8
.B flag
Shows a flying flag of your operating system.
.TP 8
.B flame
Shows cosmic flame fractals.
.TP 8
.B forest
Shows binary trees of a fractal forest.
.TP 8
.B fract
Shows fractals.
.TP 8
.B galaxy
Shows crashing spiral galaxies.
.TP 8
.B gears
Shows GL's gears.  May not be available depending on how it was configured.
.TP 8
.B geometry
Shows morphing of a complete graph.
.TP 8
.B grav
Shows orbiting planets.
.TP 8
.B helix
Shows string art.
.TP 8
.B hop
Shows real plane iterated fractals.
.TP 8
.B hyper
Shows a spinning tesseract in 4D space.
.TP 8
.B ico
Shows a bouncing polyhedra. 
.TP 8
.B ifs
Shows a modified iterated function system. 
.TP 8
.B image
Shows randomly appearing logos. 
.TP 8
.B julia
Shows the Julia set. 
.TP 8
.B kaleid
Shows a kaleidoscope.
.TP 8
.B laser
Shows spinning lasers.
.TP 8
.B life
Shows Conway's game of life.
.TP 8
.B life1d
Shows Wolfram's game of 1D life.
.TP 8
.B life3d
Shows Bays' game of 3D life.
.TP 8
.B lightning
Shows Keith's fractal lightning bolts.
.TP 8
.B lisa
Shows animated lisajous loops.
.TP 8
.B lissie
Shows lissajous worms.
.TP 8
.B loop
Shows Langton's self-producing loops.
.TP 8
.B marquee
Shows messages.
.TP 8
.B maze
Shows a random maze and a depth first search solution.
.TP 8
.B morph3d
Shows GL morphing polyhedra.  May not be available depending on how it
was configured.
.TP 8
.B mountain
Shows Papo's mountain range.
.TP 8
.B nose
Shows a man with a big nose runs around spewing out messages.
.TP 8
.B pacman
Shows Pacman(tm).
.TP 8
.B pipes
Shows a selfbuilding pipe system.  May not be available depending on how it
was configured.
.TP 8
.B penrose
Shows Penrose's quasiperiodic tilings.
.TP 8
.B petal
Shows various GCD Flowers.
.TP 8
.B puzzle
Shows a puzzle being scrambled and then solved.
.TP 8
.B pyro
Shows fireworks.
.TP 8
.B qix
Shows spinning lines a la Qix(tm).
.TP 8
.B roll
Shows a rolling ball.
.TP 8
.B rotor
Shows Tom's Roto-Rooter.
.TP 8
.B shape 
Shows stippled rectangles, ellipses, and triangles.
.TP 8
.B slip
Shows slipping blits. 
.TP 8
.B sphere
Shows a bunch of shaded spheres.
.TP 8
.B spiral
Shows helixes of dots.
.TP 8
.B spline
Shows colorful moving splines.
.TP 8
.B sproingies
Shows Sproingies!  Nontoxic.  Safe for pets and small children.
May not be available depending on how it was configured.
.TP 8
.B star 
Shows a star field with a twist.
.TP 8
.B strange
Shows strange attractors.
.TP 8
.B superquadrics
Shows 3D mathematical shapes.  May not be available depending on how it
was configured.
.TP 8
.B swarm
Shows a swarm of bees following a wasp.
.TP 8
.B swirl
Shows animated swirling patterns.
.TP 8
.B tri
Shows a Sierpinski's triangle.
.TP 8
.B triangle
Shows a triangular mountain range.
.TP 8
.B tube
Shows an animated tube.
.TP 8
.B turtle
Shows turtle fractals.
.TP 8
.B wator
Shows Dewdney's Water-Torus planet of fish and sharks.
.TP 8
.B wire
Shows a random circuit with 2 electrons.
.TP 8
.B world
Shows spinning Earths.
.TP 8
.B worm
Shows wiggly worms.
.TP 8
.B blank
Shows nothing but a black screen.  Does not show up in random mode.
.TP 8
.B bomb
Shows a bomb and will autologout after a time.  Does not show up in random
mode and may be available depending on how it was configured.
.TP 8
.B random
Shows a random mode from above except blank (and bomb).

.TP 5
.BI \-delay \ usecs
The
.I delay
option sets the speed at which a mode will operate.  It simply sets the
number of microseconds to delay between batches of animations.  In
blank mode, it is important to set this to some small number of seconds,
because the keyboard and mouse are only checked after each delay, so you
cannot set the delay too high, but a delay of zero would needlessly
consume cpu checking for mouse and keyboard input in a tight loop, since
blank mode has no work to do.
.TP 5
.BI \-batchcount \ num
The
.I batchcount
option sets number of
.I things
to do per batch to
.I num .

In ant mode this refers the number of ants.

In ball mode it is the number of balls.

In bat mode it is the number of bats, could be less because of conflicts.

In blot mode this refers to the number of pixels rendered in the same color.

In bouboule mode it is the number of stars.

In bounce mode it is the number of balls, could be less because of conflicts.

In braid mode it is the upper bound number of strands.

In bug mode it is the number of bugs, could be less because of conflicts.

In cartoon mode it means nothing.

In clock mode it is the percentage of the screen, but less than 100%.

In daisy mode it is the number flowers that make a meadow.

In dclock mode it means nothing.

In demon mode this refers the number of colors.

In drift mode it is the number of levels to recurse (larger = more complex).

In eyes mode it is the number of eyes.

In flame mode it is the number of levels to recurse (larger = more complex).

In forest mode it is the number trees that make a forest.

In fract mode it is means nothing.

In galaxy mode it means the number of galaxies.

In gears mode it is means nothing.

In geometry mode it is the number of vertices.

In grav mode it is the number of planets.

In helix mode it means nothing.

In hop mode this refers to the number of pixels rendered in the same color.

In hyper mode it means nothing.

In ico mode it is the ith plantonic solid.

In ifs mode it means nothing.

In image mode it means it is the number of logos on screen at once.

In julia mode it is the depth of recursion.

In kaleid mode it means nothing.

In laser mode it is the number lasers.

In life mode it is the number of generations before a glider is introduced.

In life1d mode it means nothing.

In life3d mode it is the number of generations before a glider is introduced.

In lisa mode it is the number of loops.

In lissie mode it is the number of worms.

In loop mode it means nothing.

In marquee mode it means nothing.

In maze mode it means nothing.

In morph3d mode it is the ith plantonic solid.

In mountain mode it is the number of mountains. 

In nose mode it means nothing.

In qix mode it is the number of lines rendered in the same color.

In pacman mode it means the number of ghosts.

In penrose mode it means nothing.

In petal mode it the greatest random number of petals.

In pipes mode it shows different joints, 0 random, 1 spherical, 2 elbow, and
3 alternating.

In puzzle mode it the number of moves.

In pyro mode it is the maximum number flying rockets at one time.

In rotor mode it is the number of points.

In rotor mode it is the number of rotor thingys which whirr...

In shape mode it means nothing.

In slip mode it means nothing.

In sphere mode it means nothing.

In spiral mode it is the number of spirals.

In spline mode it is the number of points "splined".

In sproingies mode it is the number of sproingies.

In star mode it is the number of stars on the screen at once.

In strange mode it means nothing.

In superquadrics mode its the number of horizontal and vertical lines in
the superquadric. 

In swirl mode it means the number of "knots".

In swarm mode it is the number of bees.

In tri mode it is the number of points. 

In triangular mode it is the number of mountains. 

In tube mode it means nothing.

In turtle mode it means nothing.

In wator mode it means the breed time for the fish.

In wire mode it means the length of the circuit.

In world mode it is the number of worlds.

In worm mode it is the number of worms.

In blank mode it means nothing.

In bomb mode it means the number of minutes to autologout.

A negative
.I batchcount
allows for randomness.  The range from the minimum allowed nonnegative
.I batchcount
for a particular mode to the
ABS(
.I batchcount
) (or maximum allowed
.I batchcount
, whichever is less).
.TP 5
.BI \-cycles \ num
The
.I cycles
option sets the number of cycles until time out for ant, blot, braid,
bug, clock, daisy, demon, eyes, flag, forest, galaxy, helix, hop, hyper,
ico, kaleid, laser, life, life1d, life3d, lisa, lissie, loop, mountain,
petal, shape, spline +erase, tri, triangle, tube, wator, and wire.  For
worm it is the length of the lines, for julia and spiral it is the length
of the trail of dots, for qix it is the number of lines, for spline -erase
it means the number of splines * 64 (for compatibility with +erase), for
pipes it is the number of systems to draw before clearing the screen, for
superquadrics it is not number of frames it takes to morph from one shape
to another.  For others it means nothing.
.TP 5
.BI \-size \ num
The
.I size
option sets the size maximum size of a star in bouboule, pyro and star,
size of ball in ball and bounce, size of bat in bat, size of clock in clock,
size of polyhedron in ico, size of lissie in lissie, size of dots of flag,
width of maze hallway, size of side of penrose tile, radius of loop in lisa,
radius of ball in roll, size of tube in tube, width of worm in worm, size of
cells in ant, bug, life, life1d, pacman, wator, and wire.  In pipes it is
the maximum length of a system.  In sproingies it is the size of the screen.
A negative number allows for randomness, similar to
.I batchcount.
.TP 5
.BI \-saturation \ value
The
.I saturation
option sets saturation of the color ramp used to
.I value .
0 is grayscale and 1 is very rich color.  0.4 is a nice pastel.
.TP 5
.B +/-nolock
The
.I nolock
option causes
.B xlock
to only draw the patterns and not lock the display.
A key press or a mouse click will terminate the screen saver.
.TP 5
.B -/+inwindow
Runs
.B xlock
in a window, so that you can iconify, move, or resize it and
still use your screen for other stuff.  When running in a window,
.B xlock
no longer locks your screen, it just looks good.
.TP 5
.B -/+inroot
Runs
.B xlock
in your root window.  Like the
.I inwindow
option it no longer locks the screen, it just looks good.
.TP 5
.B -/+remote
The
.I remote
option tells
.B xlock
to not stop you from locking remote X11 servers.  This option should be
used with care and is intended mainly to lock X11 terminals which cannot
run
.B xlock
locally.  If you lock someone else's workstation, they will have to know
.B your
password to unlock it.  Using
.I +remote
overrides any resource derived values for
.I remote
and prevents
.B xlock
from being used to lock other X11 servers.  (Use `+' instead of `-' to
override resources for other options that can take the `+' modifier
similarly.)
.TP 5
.B -/+mono
The
.I mono
option causes
.B xlock
to display monochrome, (black and white) pixels rather than the default
colored ones on color displays.
.TP 5
.B -/+allowaccess
This option is required for servers which do not allow clients to modify
the host access control list.  It is also useful if you need to run x
clients on a server which is locked for some reason...  When
.I allowaccess
is true, the X11 server is left open for clients to attach and thus
lowers the inherent security of this lock screen.  A side effect of using
this option is that if
.B xlock
is killed -KILL, the access control list is not lost.
.TP 5
.B -/+allowroot
The
.I allowroot
option allows the root password to unlock the server as well as the user
who started
.BR xlock .
May not be able to turn this on and off depending on your system and how
.B xlock
was configured.
.TP 5
.B -/+debug
Allows
.B xlock
to be debugged by doing all but locking the screen.
.TP 5
.B -/+echokeys
The
.I echokeys
option causes
.B xlock
to echo '?' characters for each key typed into the password prompt.
Some consider this a security risk, so the default is to not echo
anything. 
.TP 5
.B -/+enablesaver
By default
.B xlock
will disable the normal X server's screen saver since
it is in effect a replacement for it.  Since it is possible to set delay
parameters long enough to cause phosphor burn on some displays, this
option will turn back on the default screen saver which is very careful
to keep most of the screen black.
.TP 5
.B -/+grabmouse
The
.I grabmouse
option causes
.B xlock
to grab the mouse and keyboard, this is the default.
.B xlock
can not lock the screen without this.
.TP 5
.B -/+install
Allows
.B xlock
to install its own colormap if
.B xlock
runs out of colors.
May not work on with some window managers (fvwm) and does not work with
the -inroot option.
.TP 5
.B -/+sound
Allows you to turn on and off sound if installed with the capability.
.TP 5
.B -/+timeelapsed
Allows you to find out how long a machine is locked so you can complain
to an administrator that someone is hogging a machine.
.TP 5
.B -/+usefirst
The
.I usefirst
option causes
.B xlock
to use the keystroke which got you to the password screen as the first
character in the password.  The default is to ignore the first key
pressed.
.TP 5
.B -/+verbose
Verbose mode, tells what options it is going to use.
.TP 5
.BI \-nice \ nicelevel
The
.I nice
option sets system nicelevel of the
.B xlock
process to
.I nicelevel .
.TP 5
.BI \-lockdelay \ seconds
The
.I lockdelay
option sets the number of
.I seconds
before the screen needs a password to be unlocked.  Good for use with
an autolocking mechanism like xautolock(1).
.TP 5
.BI \-timeout \ seconds
The
.I timeout
option sets the number of
.I seconds
before the password screen will time out.
.TP 5
.BI \-font \ fontname
The
.I font
option sets the font to be used on the prompt screen.
.TP 5
.BI \-msgfont \ fontname
option sets the font to be used for the message that is displayed in
the lower part of the password screen.
.TP 5
.BI \-fg \ color
The
.I fg
option sets the color of the text on the password screen to
.I color .
.TP 5
.BI \-bg \ color
The
.I bg
option sets the color of the background on the password screen to
.I color .
.TP 5
.BI \-foreground \ color
The
.I foreground
option sets the color of the text on the password screen to
.I color .
.TP 5
.BI \-background \ color
The
.I background
option sets the color of the background on the password screen to
.I color .
.TP 5
.BI \-username \ string
Text
.I string
is shown in front of user name, defaults to "Name: ".
.TP 5
.BI \-password \ string
Text
.I string
is the password prompt string, defaults to "Password: ".
.TP 5
.BI \-info \ string
Text
.I string
is an informational message to tell the user what to do, defaults to
"Enter password to unlock; select icon to lock.".
.TP 5
.BI \-validate \ string
Text
.I string
is a message shown while validating the password, defaults to
"Validating login..."
.TP 5
.BI \-invalid \ string
Text
.I string
is a message shown when password is invalid, defaults to
"Invalid login."
.TP 5
.BI \-geometry \ geom
The
.I geometry
option sets
.I geom
the size and offset of the lock window (normally the entire screen).
The entire screen format is still used for entering the password.  The
purpose is to see the screen even though it is locked.  This should be
used with caution since many of the modes will fail if the windows
are far from square or are too small (size must be greater than 0x0).
This should also be used with -enablesaver to protect screen from
phosphor burn.
.TP 5
.BI \-icongeometry \ geom
The
.I icongeometry
option sets
.I geom
the size of the iconic screen (normally 64x64) seen when entering the
password.  This should be used with caution since many of the modes will
fail if the windows are far from square or are too small (size must be
greater than 0x0).  The greatest size is 256x256.  There should be some
limit so users could see who has locked the screen.  Position
information of icon is ignored.
.TP 5
.B -/+fullrandom
Turn on/off randomness options within modes.  Not implemented on all
mode options.
.TP 5
.B -/+wireframe
Turn on/off wireframe, available on gears and superquadrics.  Other modes
should use this in the future as well (e.g. daisy, life3d, sproingies,
triangle).
.TP 5
.B -/+use3d
Turn on/off 3d view, available on bouboule, pyro, star, and worm.
.TP 5
.BI \-delta3d \ value
Space between the center of your 2 eyes for 3d mode.
.TP 5
.BI \-none3d \ color
Color used for empty size in 3d mode.
.TP 5
.BI \-right3d \ color
Color used for right eye in 3d mode.
.TP 5
.BI \-left3d \ color
Color used for left eye in 3d mode.
.TP 5
.BI \-both3d \ color
Color used for overlapping images for left and right eye in 3d mode.
.TP 5
.BI \-program \ programname
The
.I program
option sets the program to be used as the fortune generator.  Currently
used only for marquee and nose modes.
.TP 5
.BI \-messagesfile \ formatted-filename
The
.I messagesfile
option sets the file to be used as the fortune generator.  The first
entry is the number of fortunes, the next line contains the first fortune.
Fortunes begin with a "%%" on a line by itself.  Currently used only for
marquee and nose modes.  If one exists, it takes precedence over the
fortune program.
.TP 5
.BI \-messagefile \ filename
The
.I messagefile
option sets the file where the contents are the message.  Currently
used only for marquee and nose modes.  If one exists, it takes
precedence over the fortune program and messagesfile.
.TP 5
.BI \-message \ textstring
The
.I message
option sets the message.  Currently used only for marquee and nose modes.
If one exists, it takes precedence over the fortune program,
messagesfile and messagefile.
.TP 5
.BI \-mfont \ mode-fontname
The
.I mfont
option sets the font to be used in the mode.  Currently used only for
marquee and nose modes.
.TP 5
.BI \-imagefile \ filename
The
.I imagefile
option sets the ras or xpm file to be displayed with image or puzzle mode.
Raster files work with -install as well.
.sp
.SH "MORE OPTIONS (these may not be available)"
.TP 5
.BI \-cpasswd  \ crypted-password
The
.I cpasswd
option sets the key to be this text string to unlock
.B xlock
instead of password file.
.TP 5
.BI \-forceLogout \ minutes
The
.I forceLogout
option sets
.I minutes
to auto-logout.
.TP 5
.BI \-logoutButtonLabel \ string
Text
.I string
is a message shown inside logout button when logout button is displayed.
Defaults to
"Logout".
.TP 5
.BI \-logoutButtonHelp \ string
Text
.I string
is a message shown outside logout button when logout button is
displayed.  Defaults to
"Click the \\"Logout\\" button to log out current\\n
user and make workstation available."
.TP 5
.BI \-logoutFailedString \ string
Text
.I string
is a message shown when a logout is attempted and fails.
Defaults to
"Logout attempt FAILED.\\n
Current user could not be automatically logged out."
.TP 5
.B -/+dtsaver
Turn on/off CDE Saver Mode.
.TP 5
.BI \-locksound \ string
Text
.I string
references sound to use at lock time.  Default sound, male voice:
"Thank you, for your cooperation."
.TP 5
.BI \-infosound \ string
Text
.I string
references sound to use for information.  Default sound, male voice:
"Identify please."
.TP 5
.BI \-validsound \ string
Text
.I string
references sound to when a password is valid.  Default sound, female voice:
"Complete."
.TP 5
.BI \-invalidsound \ string
Text
.I string
references sound to when a password is invalid.  Default sound, female
voice: "I am not programmed to give you that information."
.sp
.SH "SPECIAL MODE DEPENDENT OPTIONS"
.TP 5
.BI -/+truchet
Turn on and off Truchet lines (trail) in
.I ant.
.TP 5
.BI -/+grow
Turn on and off growing fractals (else they are animated) for
.I drift.
.TP 5
.BI -/+liss
Turn on and off using lissojous figures to get points for
.I drift.
.TP 5
.BI -/+decay
Turn on and off decaying orbits for
.I grav.
.TP 5
.BI -/+trail
Turn on and off decaying trail of dots for
.I grav.
.TP 5
.BI \-rule \ num
Allows one to set
.I life
parameters <living_min><living_max><birth_min><birth_max>.  For example,
Conway's rule is 2333.  Unfortunately, this requires the rule to be
contiguous.
.TP 5
.BI -/+totalistic
Turn on and off totalistic rules for
.I life1d.
If this is off then it follows rules of the LCAU collection.  These
rules may not be symmetric and are more general.
.TP 5
.BI \-rule3d \ num
Allows one to set
.I life3d
parameters <living_min><living_max><birth_min><birth_max>.  For example,
Bay's 4 rules are 4555, 5766, 5655, and 6767.  Unfortunately, this requires
the rule to be contiguous.
.TP 5
.BI -/+ammann
Turn on and off lines for
.I penrose.
.TP 5
.BI -/+erase
Turn on and off erasing for
.I spline.
If this option is on,
.I cycles
should probably be set to around 10 or so else
it should be much larger, around 2000.
.BI \-trek \ num
If its a high number you will see the space ship all the time in
.I star.
.TP 5
.BI -/+rock
Turn on and off rocks for
.I star.
If this is off, stars will be seen instead.
.TP 5
.BI -/+straight
Turn on if
.I star
gets you motion sick.
.TP 5
.BI \-duration \ seconds
Allows one to set a duration for a mode in
.I random.
Duration of 0 is defined as infinite.
.TP 5
.BI \-modelist \ textstring
Allows one to pass a list of files to randomly display to
.I random.
"all" will get all files but blank (and bomb if compiled in). "all,blank"
will get all modes.  "all,-image bounce,+blank" will get all modes but
image and bounce.  "bug wator" will get only bug and wator.  "allstable"
will weed out hackers modes if compiled in, "allstandard will weed out
the GL modes (as well as hackers modes) if compiled in ("allgl" will get
only these modes as well as "allstable-allstandard), "allnice" will weed
out high cpu usage modes (as well as hackers and gl modes).  "random" can
not be referenced.
.TP 5
.BI -/+sequential
Turn on non-random
.I random
option.
.sp
.SH **WARNING**
.B xlock
can appear to hang if it is competing with a high-priority process for
the CPU. For example, if
.B xlock
is started after a process with 'nice -20'
(high priority),
.B xlock
will take  considerable amount of time to respond.
.sp
.SH "SHADOW PASSWORDS"
If the machine is using a shadow password system, then
.B xlock
may not be set up to get the real password and so must be given one
of its own. This can be either on the command line, via the
.B -cpasswd
option,
or in the file
.BR $HOME/.xlockrc ,
with the first taking precedence.  In both cases an encrypted password
is expected (see makekey(8)).  If neither is given, then
.B xlock
will prompt for a password and will use that, also storing an
encrypted version of it in
.B $HOME/.xlockrc
for future use.
.sp
.SH BUGS
"kill -KILL
.B xlock
" causes the server that was locked to be unusable, since all hosts
(including localhost) were removed from the access control list
to lock out new X clients, and since
.B xlock
could not catch SIGKILL, it terminated before restoring the access
control list.  This will leave the X server in a state where
\fI"you can no longer connect to that server,
and this operation cannot be reversed unless you reset the server."\fP
		-From the X11R4 Xlib Documentation, Chapter 7.
.br
NCD terminals do not allow xlock to remove all the hosts from the access
control list.  Therefore you will need to use the "-remote" and
"-allowaccess" switches.  If you happen to run without "-allowaccess" on an
NCD terminal,
.B xlock
will not work and you will need to reboot the terminal, or simply go into
the SETUP menus, under 'Network Parameters', and turn off TCP/IP access
control. 
.br
.SH "SEE ALSO"
X(1), Xlib Documentation.
.sp
.SH AUTHOR
Maintained by:
.br
 David A. Bagley      (bagleyd@bigfoot.com)
.br
 The latest version is currently at:
.br
 ftp.x.org in /contrib/applications/xlockmore-4.??.tar.gz
.sp
Original Author:
.br
 Patrick J. Naughton	 (naughton@eng.sun.com)
.br
 Mailstop 21-14
.br
 Sun Microsystems Laboratories, Inc.
.br
 Mountain View, CA  94043
.br
 415/336-1080
.sp
with many additional contributors.
.sp
.SH COPYRIGHT
Copyright (c) 1988-91 by Patrick J. Naughton
.br
Copyright (c) 1993-97 by David A. Bagley
.sp
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation. 
.br
The original BSD daemon is Copyright (c) 1988 Marshall Kirk McKusick.
All Rights Reserved.
.br
Sun, HP, and SGI icons have their respective copyrights.
